import { HKTS } from '../xs';
import { FantasyX } from './fantasyx';
import { Plan } from '../interfaces';
import { Partial } from './interfaces';
export declare function fromPlan<E extends HKTS, I, S>(plan: Plan<E, I, S>): FantasyX<E, I, S>;
export declare function pure<E extends HKTS, I, S>(s: S): FantasyX<E, I, S>;
export declare function map<E extends HKTS, I, A>(f: (s: Partial<A>) => Partial<A>, fa: FantasyX<E, I, A>): FantasyX<E, I, A>;
export declare function lift<E extends HKTS, I, A>(f: (s: Partial<A>) => Partial<A>): (fa: FantasyX<E, I, A>) => FantasyX<E, I, A>;
export declare function lift2<E extends HKTS, I, A>(f: (s1: Partial<A>, s2: Partial<A>) => Partial<A>): (fa1: FantasyX<E, I, A>, fa2: FantasyX<E, I, A>) => FantasyX<E, I, A>;
export declare function lift3<E extends HKTS, I, A>(f: (s1: Partial<A>, s2: Partial<A>, s3: Partial<A>) => Partial<A>): (fa1: FantasyX<E, I, A>, fa2: FantasyX<E, I, A>, fa3: FantasyX<E, I, A>) => FantasyX<E, I, A>;
export declare function lift4<E extends HKTS, I, A>(f: (s1: Partial<A>, s2: Partial<A>, s3: Partial<A>, s4: Partial<A>) => Partial<A>): (fa1: FantasyX<E, I, A>, fa2: FantasyX<E, I, A>, fa3: FantasyX<E, I, A>, fa4: FantasyX<E, I, A>) => FantasyX<E, I, A>;
export declare function lift5<E extends HKTS, I, A>(f: (s1: Partial<A>, s2: Partial<A>, s3: Partial<A>, s4: Partial<A>, s5: Partial<A>) => Partial<A>): (fa1: FantasyX<E, I, A>, fa2: FantasyX<E, I, A>, fa3: FantasyX<E, I, A>, fa4: FantasyX<E, I, A>, fa5: FantasyX<E, I, A>) => FantasyX<E, I, A>;
export declare function concat<E extends HKTS, I, A>(fa: FantasyX<E, I, A>, fb: FantasyX<E, I, A>): FantasyX<E, I, A>;
