"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var xs_1 = require("../xs");
var fantasyx_1 = require("./fantasyx");
var state_1 = require("./state");
function fromPlan(plan) {
    return new fantasyx_1.FantasyX(function (intent$) {
        var _a = plan(intent$), update$ = _a.update$, actions = _a.actions;
        return {
            actions: actions,
            update$: xs_1.streamOps.map(function (f) { return state_1.State.patch(f); }, update$)
        };
    });
}
exports.fromPlan = fromPlan;
function pure(s) {
    return new fantasyx_1.FantasyX(function (intent$) {
        return {
            update$: xs_1.streamOps.map(function () { return state_1.State.pure(s); }, intent$)
        };
    });
}
exports.pure = pure;
function map(f, fa) {
    return fa.map(f);
}
exports.map = map;
function lift(f) {
    return function (fa) { return fa.map(f); };
}
exports.lift = lift;
function lift2(f) {
    return function (fa1, fa2) { return fa1.combine(f, fa2); };
}
exports.lift2 = lift2;
function lift3(f) {
    return function (fa1, fa2, fa3) { return fa1.combine3(f, fa2, fa3); };
}
exports.lift3 = lift3;
function lift4(f) {
    return function (fa1, fa2, fa3, fa4) { return fa1.combine4(f, fa2, fa3, fa4); };
}
exports.lift4 = lift4;
function lift5(f) {
    return function (fa1, fa2, fa3, fa4, fa5) { return fa1.combine5(f, fa2, fa3, fa4, fa5); };
}
exports.lift5 = lift5;
function concat(fa, fb) {
    return fa.concat(fb);
}
exports.concat = concat;
