"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var xs_1 = require("../xs");
var state_1 = require("./state");
// function chainAll(chainables, f, paras) {
//   if (chainables.length == 1) {
//     return chainables[0].chain(s => {
//       return State.pure(f.apply(null, paras))
//     })
//   } else {
//     let [head, ...tail] = chainables
//     return head.chain(s => {
//       return chainAll(tail, f, paras.concat(s))
//     })
//   }
// }
var PlanX = /** @class */ (function () {
    function PlanX(plan) {
        this.apply = plan;
    }
    PlanX.prototype.combine = function (f, planB) {
        var _this = this;
        return new PlanX(function (intent$) {
            var machineB = planB.apply(intent$), machineA = _this.apply(intent$);
            var update$ = xs_1.streamOps.combine(function (S1, S2) {
                return S1.chain(function (s1) {
                    return S2.chain(function (s2) {
                        return state_1.State.patch(function () { return f(s1, s2); });
                    });
                });
            }, machineA.update$, machineB.update$);
            var actions = Object.assign({}, machineA.actions, machineB.actions);
            return { update$: update$, actions: actions };
        });
    };
    PlanX.prototype.combine3 = function (f, planB, planC) {
        var _this = this;
        return new PlanX(function (intent$) {
            var machineB = planB.apply(intent$), machineA = _this.apply(intent$), machineC = planC.apply(intent$);
            var update$ = xs_1.streamOps.combine(function (S1, S2, S3) {
                return S1.chain(function (s1) {
                    return S2.chain(function (s2) {
                        return S3.chain(function (s3) {
                            return state_1.State.patch(function () { return f(s1, s2, s3); });
                        });
                    });
                });
            }, machineA.update$, machineB.update$, machineC.update$);
            var actions = Object.assign({}, machineA.actions, machineB.actions, machineC.actions);
            return { update$: update$, actions: actions };
        });
    };
    PlanX.prototype.combine4 = function (f, planB, planC, planD) {
        var _this = this;
        return new PlanX(function (intent$) {
            var machineB = planB.apply(intent$), machineA = _this.apply(intent$), machineC = planC.apply(intent$), machineD = planD.apply(intent$);
            var update$ = xs_1.streamOps.combine(function (S1, S2, S3, S4) {
                return S1.chain(function (s1) {
                    return S2.chain(function (s2) {
                        return S3.chain(function (s3) {
                            return S4.chain(function (s4) {
                                return state_1.State.patch(function () { return f(s1, s2, s3, s4); });
                            });
                        });
                    });
                });
            }, machineA.update$, machineB.update$, machineC.update$, machineD.update$);
            var actions = Object.assign({}, machineA.actions, machineB.actions, machineC.actions, machineD.actions);
            return { update$: update$, actions: actions };
        });
    };
    PlanX.prototype.combine5 = function (f, planB, planC, planD, planE) {
        var _this = this;
        return new PlanX(function (intent$) {
            var machineB = planB.apply(intent$), machineA = _this.apply(intent$), machineC = planC.apply(intent$), machineD = planD.apply(intent$), machineE = planE.apply(intent$);
            var update$ = xs_1.streamOps.combine(function (S1, S2, S3, S4, S5) {
                return S1.chain(function (s1) {
                    return S2.chain(function (s2) {
                        return S3.chain(function (s3) {
                            return S4.chain(function (s4) {
                                return S5.chain(function (s5) {
                                    return state_1.State.patch(function () { return f(s1, s2, s3, s4, s5); });
                                });
                            });
                        });
                    });
                });
            }, machineA.update$, machineB.update$, machineC.update$, machineD.update$, machineE.update$);
            var actions = Object.assign({}, machineA.actions, machineB.actions, machineC.actions, machineD.actions, machineE.actions);
            return { update$: update$, actions: actions };
        });
    };
    PlanX.prototype.concat = function (fa) {
        var _this = this;
        return new PlanX(function (intent$) {
            var machineA = _this.apply(intent$);
            var machineB = fa.apply(intent$);
            var update$ = xs_1.streamOps.merge(machineA.update$, machineB.update$);
            return { update$: update$, actions: Object.assign({}, machineA.actions, machineB.actions) };
        });
    };
    PlanX.prototype.map = function (f) {
        var _this = this;
        return new PlanX(function (intent$) {
            var machine = _this.apply(intent$);
            var update$ = xs_1.streamOps.map(function (state) { return state.chain(function () { return state_1.State.patch(f); }); }, machine.update$);
            return { update$: update$, actions: machine.actions };
        });
    };
    PlanX.prototype.bimap = function (fa, fb) {
        var _this = this;
        return new PlanX(function (intent$) {
            var machine = _this.apply(intent$);
            var update$ = xs_1.streamOps.map(function (state) { return state.chain(function () { return state_1.State.patch(fb); }); }, machine.update$);
            return { update$: update$, actions: fa(machine.actions) };
        });
    };
    PlanX.prototype.toPlan = function () {
        var _this = this;
        return function (intent$) {
            var machine = _this.apply(intent$);
            var update$ = xs_1.streamOps.map(function (s) { return s.runS.bind(s); }, machine.update$);
            return { update$: update$, actions: machine.actions };
        };
    };
    return PlanX;
}());
exports.PlanX = PlanX;
