import { pair, Partial } from './interfaces';
export declare class State<S, A> {
    runState: (s: S) => pair<S, A>;
    constructor(runState: (s: S) => pair<S, A>);
    static pure<A>(a: A): State<any, A>;
    chain<B>(f: (a: A) => State<S, B>): State<S, B>;
    runA(state: S): A;
    runS(state: S): S;
    static get<S>(): State<S, S>;
    static put<S>(s: S): State<S, void>;
    static modify<S>(f: (s: S) => S): State<S, void>;
    static patch<S>(f: (s: S) => Partial<S>): State<S, Partial<S>>;
}
