"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var State = /** @class */ (function () {
    function State(runState) {
        this.runState = runState;
    }
    State.pure = function (a) {
        return new State(function (s) { return ({ s: s, a: a }); });
    };
    State.prototype.chain = function (f) {
        var _this = this;
        return new State(function (state) {
            var _a = _this.runState(state), a = _a.a, s = _a.s;
            return f(a).runState(s);
        });
    };
    State.prototype.runA = function (state) {
        return this.runState(state).a;
    };
    State.prototype.runS = function (state) {
        return this.runState(state).s;
    };
    State.get = function () {
        return new State(function (s) { return ({ s: s, a: s }); });
    };
    State.put = function (s) {
        return new State(function (_) { return ({ a: undefined, s: s }); });
    };
    State.modify = function (f) {
        return new State(function (s) { return ({ a: undefined, s: f(s) }); });
    };
    State.patch = function (f) {
        return new State(function (s) {
            var p = f(s);
            return {
                a: p, s: Object.assign({}, s, p)
            };
        });
    };
    return State;
}());
exports.State = State;
