"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var prop_types_1 = require("prop-types");
var interfaces_1 = require("./interfaces");
var xs_1 = require("./xs");
exports.CONTEXT_TYPE = (_a = {},
    _a[interfaces_1.XREACT_ENGINE] = prop_types_1.PropTypes.shape({
        intent$: prop_types_1.PropTypes.object,
        operators: prop_types_1.PropTypes.object
    }),
    _a);
function isSFC(Component) {
    return (typeof Component == 'function');
}
function extendXComponentClass(WrappedComponent, main) {
    return _a = /** @class */ (function (_super) {
            __extends(XNode, _super);
            function XNode(props, context) {
                var _this = _super.call(this, props, context) || this;
                var engine = context[interfaces_1.XREACT_ENGINE];
                var _a = main(engine.intent$, props), actions = _a.actions, update$ = _a.update$;
                _this.machine = {
                    update$: xs_1.streamOps.merge(_this.machine.update$, update$),
                    actions: Object.assign({}, bindActions(actions, context[interfaces_1.XREACT_ENGINE].intent$, _this), _this.machine.actions)
                };
                return _this;
            }
            return XNode;
        }(WrappedComponent)),
        _a.contextTypes = exports.CONTEXT_TYPE,
        _a.displayName = "X(" + getDisplayName(WrappedComponent) + ")",
        _a;
    var _a;
}
exports.extendXComponentClass = extendXComponentClass;
function genXComponentClass(WrappedComponent, main, opts) {
    return _a = /** @class */ (function (_super) {
            __extends(XLeaf, _super);
            function XLeaf(props, context) {
                var _this = _super.call(this, props, context) || this;
                var engine = context[interfaces_1.XREACT_ENGINE];
                var _a = main(engine.intent$, props), actions = _a.actions, update$ = _a.update$;
                _this.machine = {
                    actions: bindActions(actions, engine.intent$, _this),
                    update$: update$
                };
                _this.defaultKeys = WrappedComponent.defaultProps ? Object.keys(WrappedComponent.defaultProps) : [];
                _this.state = Object.assign({}, WrappedComponent.defaultProps, pick(_this.defaultKeys, props));
                return _this;
            }
            XLeaf.prototype.componentWillReceiveProps = function (nextProps) {
                var _this = this;
                this.setState(function (state) { return Object.assign({}, nextProps, pick(_this.defaultKeys, state)); });
            };
            XLeaf.prototype.componentDidMount = function () {
                var _this = this;
                this.subscription = xs_1.streamOps.subscribe(this.machine.update$, function (action) {
                    if (action instanceof Function) {
                        if (process.env.NODE_ENV == 'debug')
                            console.log('UPDATE:', action);
                        _this.setState(function (prevState, props) {
                            var newState = action.call(_this, prevState, props);
                            var newStateWithoutPromise = {};
                            for (var i in newState) {
                                if (isPromise(newState[i])) {
                                    newState[i].then(function (v) { return _this.setState(v); });
                                }
                                else {
                                    newStateWithoutPromise[i] = newState[i];
                                }
                            }
                            _this.context[interfaces_1.XREACT_ENGINE].history$.next(newStateWithoutPromise);
                            if (process.env.NODE_ENV == 'debug')
                                console.log('STATE:', newStateWithoutPromise);
                            return newStateWithoutPromise;
                        });
                    }
                    else {
                        /* istanbul ignore next */
                        console.warn('action', action, 'need to be a Function which map from current state to new state');
                    }
                }, function () {
                    _this.context[interfaces_1.XREACT_ENGINE].history$.complete(_this.state);
                    if (process.env.NODE_ENV == 'production') {
                        console.error('YOU HAVE TERMINATED THE INTENT STREAM...');
                    }
                    if (process.env.NODE_ENV == 'debug') {
                        console.log("LAST STATE is", _this.state);
                    }
                });
            };
            XLeaf.prototype.componentWillUnmount = function () {
                this.subscription.unsubscribe();
            };
            XLeaf.prototype.render = function () {
                if (isSFC(WrappedComponent)) {
                    return react_1.createElement(WrappedComponent, Object.assign({}, opts, this.props, this.state, {
                        actions: this.machine.actions,
                    }));
                }
                else {
                    return react_1.createElement(WrappedComponent, Object.assign({}, opts, this.props, this.state, {
                        actions: this.machine.actions,
                    }));
                }
            };
            return XLeaf;
        }(interfaces_1.Xcomponent)),
        _a.contextTypes = exports.CONTEXT_TYPE,
        _a.displayName = "X(" + getDisplayName(WrappedComponent) + ")",
        _a;
    var _a;
}
exports.genXComponentClass = genXComponentClass;
function getDisplayName(WrappedComponent) {
    return WrappedComponent.displayName || WrappedComponent.name || 'X';
}
function bindActions(actions, intent$, self) {
    var _actions = {
        fromEvent: function (e, f) {
            if (f === void 0) { f = function (x) { return x; }; }
            return intent$.next(f(e));
        },
        fromPromise: function (p) {
            return p.then(function (x) { return intent$.next(x); });
        },
        terminate: function (a) {
            if (process.env.NODE_ENV == 'debug')
                console.error('INTENT TERMINATED');
            return intent$.complete(a);
        }
    };
    var _loop_1 = function (a) {
        _actions[a] = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return intent$.next(actions[a].apply(self, args));
        };
    };
    for (var a in actions) {
        _loop_1(a);
    }
    return _actions;
}
function pick(names, obj) {
    var result = {};
    for (var _i = 0, names_1 = names; _i < names_1.length; _i++) {
        var name_1 = names_1[_i];
        if (obj[name_1])
            result[name_1] = obj[name_1];
    }
    return result;
}
function isPromise(p) {
    return p !== null && typeof p === 'object' && typeof p.then === 'function';
}
var _a;
